#lang scheme
;; recursive definition, control context keeps on growing
;; non-tail recursive
(define (fact n)
    (if (zero? n) 
        1 
        (* n (fact (- n 1)))))


;; iterative version = tail recursive
;;control context constant (no context at all)
(define (fact-iter n) 
    (fact-iter-acc n 1))

(define (fact-iter-acc n a)
  (if (zero? n) 
      a 
      (fact-iter-acc (- n 1) 
                     (* n a))))


;; tail calls 

(define (even val)
  (cond ((eq? val 0) #t)
        ((eq? val 1) #f)
        (else (odd (- val 1)))))

(define (odd val)
  (cond ((eq? val 0) #f)
        ((eq? val 1) #t)
        (else (even (- val 1)))))

